package chap05.program01

object Main {
  def main(args: Array[String]) :Unit = {
    var list = 1::2::3::Nil

    var amount = sumList(list)
    println(amount)
  }

  // リスト1 ループ版sumList
  def sumList(list:List[Int]) :Int = {
    var amount = 0
    for (i <- list) {
      amount += i
    }
    amount
  }

  // リスト1-2 再帰版sumList
//  def sumList(list:List[Int]) :Int = {
//    list match {
//      case Nil => 0
//      case x::xs => x + sumList(xs)
//    }
//  }
}
